if ($userhost) {
    #
    # create the user
    #
    $gid = getgrnam(${param{group}});
    print "Gid is $gid\n";
    if (${param{uid}}) {
    	$uid = ${param{uid}};
    } else {
	for ($uid = $gid; getpwuid($uid); $uid++) {}
	$param{'uid'} = $uid;
    }
    print "Uid is $uid\n";
    $gecos = ${param{'fullname'}} . "," . ${param{'org'}};
    if (${param{'org2'}} ne "") {
	$gecos .= " (" . ${param{'org2'}} . ")";
    }
    $gecos .= "," . ${param{'officephone'}};
    $gecos .= "," . ${param{'homephone'}};
    print "shell is ", ${param{'shell'}}, "\n";
    if (${param{'suppgroups'}} ne "") {
	system ("/usr/sbin/useradd",
		"-u", $uid,
		"-g", ${param{'group'}},
		"-G", ${param{'suppgroups'}},
		"-c", $gecos,
		"-s", ${param{'shell'}},
		"-m",
		${param{'logname'}});
    } else {
	system ("/usr/sbin/useradd",
		"-u", $uid,
		"-g", ${param{'group'}},
		"-c", $gecos,
		"-s", ${param{'shell'}},
		"-m",
		${param{'logname'}});
    }
    if ($? != 0) {
	print "Unexpected return code $?. Aborting ...\n";
	exit(1);
    }

    #
    # change the password
    #
    # WARNING!  WARNING!  WARNING!  
    # This does not work with shadow passwords or TCB on HP-UX!
    #
    if (${param{'epwd'}} eq "") {
	if (${param{'password'}} eq "") {
	    $password=`/usr/local/bin/random_password`;
	    chomp($password);
	    print "Password is $password\n";
	    if ($password eq "") {
		print "/usr/local/bin/random_password returned an empty password. Aborting ...\n";
		exit(1);
	    }
	    ${param{'password'}} = $password;
	}
	$epwc = "./0123456789" .
		"ABCDEFGHIJKLMNOPQRSTUVWXYZ" .
		"abcdefghijklmnopqrstuvwxyz";
	$salt = substr($epwc,rand(63), 1) .
		substr($epwc,rand(63), 1);
	$epwd = crypt(${param{'password'}}, $salt);
	print "Encrypted password is $epwd\n";
	${param{'epwd'}} = $epwd;
    } else {
	$epwd = ${param{'epwd'}};
    }

    $ENV{EDITOR}="/usr/bin/ed";
    ($pid = open (VIPW, "|/usr/sbin/vipw")) || die "cannot start vipw: $!";
    $eepwd = $epwd;
    $eepwd =~ s|/|\\/|;
    $logname = $param{'logname'};
    print VIPW  "1,\$s/^$logname:[^:]*/$logname:$eepwd/\n";
    print       "1,\$s/^$logname:[^:]*/$logname:$eepwd/\n";
    print VIPW  "w\n";
    print "w\n";
    print VIPW  "q\n";
    print "q\n";
    close(VIPW);

    open(PARAM, ">$paramfile") 
	or die "cannot open $paramfile: $!";
    for $i (sort keys %param) {
	print PARAM "$i:${param{$i}}\n";
    }
    close(PARAM)
	or die "cannot close $paramfile: $!";
}
1;
